Line length: Fix recent merges
[csit.git] / resources / libraries / bash / function / per_patch.sh
index 27fa0cf..4af3302 100644 (file)
@@ -1,4 +1,5 @@
-# Copyright (c) 2018 Cisco and/or its affiliates.
+# Copyright (c) 2021 Cisco and/or its affiliates.
+# Copyright (c) 2021 PANTHEON.tech s.r.o.
 # Licensed under the Apache License, Version 2.0 (the "License");
 # you may not use this file except in compliance with the License.
 # You may obtain a copy of the License at:
@@ -15,13 +16,10 @@ set -exuo pipefail
 
 # This library defines functions used mainly by per patch entry scripts.
 # Generally, the functions assume "common.sh" library has been sourced already.
-
 # Keep functions ordered alphabetically, please.
 
 function archive_test_results () {
 
-    set -exuo pipefail
-
     # Arguments:
     # - ${1}: Directory to archive to. Required. Parent has to exist.
     # Variable set:
@@ -34,6 +32,8 @@ function archive_test_results () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory command failed."
     TARGET="$(readlink -f "$1")"
     mkdir -p "${TARGET}" || die "Directory creation failed."
@@ -47,8 +47,6 @@ function archive_test_results () {
 
 function archive_parse_test_results () {
 
-    set -exuo pipefail
-
     # Arguments:
     # - ${1}: Directory to archive to. Required. Parent has to exist.
     # Variables read:
@@ -58,6 +56,8 @@ function archive_parse_test_results () {
     # - archive_test_results - Archiving results.
     # - parse_bmrr_results - See definition in this file.
 
+    set -exuo pipefail
+
     archive_test_results "$1" || die
     parse_bmrr_results "${TARGET}" || {
         die "The function should have died on error."
@@ -67,36 +67,44 @@ function archive_parse_test_results () {
 
 function build_vpp_ubuntu_amd64 () {
 
-    set -exuo pipefail
-
-    # This function is using Vagrant script to build VPP with all dependencies
+    # This function is using make pkg-verify to build VPP with all dependencies
     # that is ARCH/OS aware. VPP repo is SSOT for building mechanics and CSIT
     # is consuming artifacts. This way if VPP will introduce change in building
     # mechanics they will not be blocked by CSIT repo.
     # Arguments:
     # - ${1} - String identifier for echo, can be unset.
     # Variables read:
+    # - MAKE_PARALLEL_FLAGS - Make flags when building VPP.
+    # - MAKE_PARALLEL_JOBS - Number of cores to use when building VPP.
     # - VPP_DIR - Path to existing directory, parent to accessed directories.
     # Directories updated:
     # - ${VPP_DIR} - Whole subtree, many files (re)created by the build process.
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory command failed."
-    echo 'Building using "make build-root/vagrant/build.sh"'
-    build-root/vagrant/"build.sh" || die "Vagrant VPP build script failed."
-    echo "*******************************************************************"
+    if [ -n "${MAKE_PARALLEL_FLAGS-}" ]; then
+        echo "Building VPP. Number of cores for build set with" \
+             "MAKE_PARALLEL_FLAGS='${MAKE_PARALLEL_FLAGS}'."
+    elif [ -n "${MAKE_PARALLEL_JOBS-}" ]; then
+        echo "Building VPP. Number of cores for build set with" \
+             "MAKE_PARALLEL_JOBS='${MAKE_PARALLEL_JOBS}'."
+    else
+        echo "Building VPP. Number of cores not set, " \
+             "using build default ($(grep -c ^processor /proc/cpuinfo))."
+    fi
+
+    make UNATTENDED=y pkg-verify || die "VPP build with make pkg-verify failed."
     echo "* VPP ${1-} BUILD SUCCESSFULLY COMPLETED" || {
         die "Argument not found."
     }
-    echo "*******************************************************************"
 }
 
 
 function compare_test_results () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - VPP_DIR - Path to directory with VPP git repo (at least built parts).
     # - ARCHIVE_DIR - Path to where robot result files are created in.
@@ -111,42 +119,12 @@ function compare_test_results () {
     # - 0 - If the comparison utility sees no regression (nor data error).
     # - 1 - If the comparison utility sees a regression (or data error).
 
-    cd "${VPP_DIR}" || die "Change directory operation failed."
-    # Reusing CSIT main virtualenv.
-    pip install -r "${PYTHON_SCRIPTS_DIR}/perpatch_requirements.txt" || {
-        die "Perpatch Python requirements installation failed."
-    }
-    python "${PYTHON_SCRIPTS_DIR}/compare_perpatch.py"
-    # The exit code determines the vote result.
-}
-
-
-function download_builds () {
-
     set -exuo pipefail
 
-    # This is mostly useful only for Sandbox testing, to avoid recompilation.
-    #
-    # Arguments:
-    # - ${1} - URL to download VPP builds from.
-    # Variables read:
-    # - VPP_DIR - Path to WORKSPACE, parent of created directories.
-    # Directories created:
-    # - archive - Ends up empty, not to be confused with ${ARCHIVE_DIR}.
-    # - build_current - Holding built artifacts of the patch under test (PUT).
-    # - built_parent - Holding built artifacts of parent of PUT.
-    # Functions called:
-    # - die - Print to stderr and exit, defined in common.sh
-
     cd "${VPP_DIR}" || die "Change directory operation failed."
-    dirs=("build-root" "build_parent" "build_current" "archive" "csit_current")
-    rm -rf ${dirs[@]} || {
-        die "Directory removal failed."
-    }
-    wget -N --progress=dot:giga "${1}" || die "Wget download failed."
-    unzip "archive.zip" || die "Archive extraction failed."
-    mv "archive/build_parent" ./ || die "Move operation failed."
-    mv "archive/build_current" ./ || die "Move operation failed."
+    # Reusing CSIT main virtualenv.
+    python3 "${TOOLS_DIR}/integrated/compare_perpatch.py"
+    # The exit code determines the vote result.
 }
 
 
@@ -154,8 +132,6 @@ function initialize_csit_dirs () {
 
     set -exuo pipefail
 
-    # This could be in prepare_test, but download_builds also needs this.
-    #
     # Variables read:
     # - VPP_DIR - Path to WORKSPACE, parent of created directories.
     # Directories created:
@@ -164,6 +140,8 @@ function initialize_csit_dirs () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     rm -rf "csit_current" "csit_parent" || {
         die "Directory deletion failed."
@@ -176,8 +154,6 @@ function initialize_csit_dirs () {
 
 function parse_bmrr_results () {
 
-    set -exuo pipefail
-
     # Currently "parsing" is just two greps.
     # TODO: Re-use PAL parsing code, make parsing more general and centralized.
     #
@@ -190,6 +166,8 @@ function parse_bmrr_results () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     rel_dir="$(readlink -e "${1}")" || die "Readlink failed."
     in_file="${rel_dir}/output.xml"
     out_file="${rel_dir}/results.txt"
@@ -206,8 +184,6 @@ function parse_bmrr_results () {
 
 function select_build () {
 
-    set -exuo pipefail
-
     # Arguments:
     # - ${1} - Path to directory to copy VPP artifacts from. Required.
     # Variables read:
@@ -220,6 +196,8 @@ function select_build () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     source_dir="$(readlink -e "$1")"
     rm -rf "${DOWNLOAD_DIR}"/* || die "Cleanup of download dir failed."
@@ -231,8 +209,6 @@ function select_build () {
 
 function set_aside_commit_build_artifacts () {
 
-    set -exuo pipefail
-
     # Function is copying VPP built artifacts from actual checkout commit for
     # further use and clean git.
     # Variables read:
@@ -245,6 +221,8 @@ function set_aside_commit_build_artifacts () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     rm -rf "build_current" || die "Remove operation failed."
     mkdir -p "build_current" || die "Directory creation failed."
@@ -262,8 +240,6 @@ function set_aside_commit_build_artifacts () {
 
 function set_aside_parent_build_artifacts () {
 
-    set -exuo pipefail
-
     # Function is copying VPP built artifacts from parent checkout commit for
     # further use. Checkout to parent is not part of this function.
     # Variables read:
@@ -275,6 +251,8 @@ function set_aside_parent_build_artifacts () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     cd "${VPP_DIR}" || die "Change directory operation failed."
     rm -rf "build_parent" || die "Remove failed."
     mkdir -p "build_parent" || die "Directory creation operation failed."
@@ -284,21 +262,19 @@ function set_aside_parent_build_artifacts () {
 
 function set_perpatch_dut () {
 
-    set -exuo pipefail
-
     # Variables set:
     # - DUT - CSIT test/ subdirectory containing suites to execute.
 
     # TODO: Detect DUT from job name, when we have more than just VPP perpatch.
 
+    set -exuo pipefail
+
     DUT="vpp"
 }
 
 
 function set_perpatch_vpp_dir () {
 
-    set -exuo pipefail
-
     # Variables read:
     # - CSIT_DIR - Path to existing root of local CSIT git repository.
     # Variables set:
@@ -306,6 +282,8 @@ function set_perpatch_vpp_dir () {
     # Functions called:
     # - die - Print to stderr and exit, defined in common.sh
 
+    set -exuo pipefail
+
     # In perpatch, CSIT is cloned inside VPP clone.
     VPP_DIR="$(readlink -e "${CSIT_DIR}/..")" || die "Readlink failed."
 }